Subject: bug#62621: 29.0.60; uniquify can't make buffers unique based on things other than filename

From: Eli Zaretskii <[email-masked]>
Date: Sun, 02 Apr 2023 20:57:08 +0300

> From: Spencer Baugh <[email-masked]>
> Date: Sun, 02 Apr 2023 13:37:36 -0400
> 
> 
> I have a lot of buffers visiting files with the same basename, in
> directory paths which have long meaningless numeric identifiers.  This
> means that with uniquify, I get buffers named things like:
> 
> foo<ahlai5Ei>, foo<IHoano7o>, foo<yoeWo3ae>
> 
> This is not much better than foo<1>, foo<2>, foo<3> for me.
> 
> What would be great is if uniquify could use things other than the
> filename when making unique buffer names.
> 
> For example, project-name from project.el is something that *is*
> unique for these files, because of my custom project.el integration.
> Then I'd get something like:
> 
> foo<proj-emacs>, foo<proj-vi>, foo<proj-nano>
> 
> However, uniquify is currently not customizable in this way.  Could we
> add support for including additional attributes into the things which
> uniquify will use?  Then I could add project-name as one of those
> attributes in my configuration, and I'd be happy.
> 
> I would be happy to implement this feature in uniquify myself, if this
> is an interesting feature for upstream.

Sounds like a useful feature indeed, provided that the customization
will allow more or less arbitrary uniquification, not just by project
names.  Also, please keep in mind that a single project could have
files named the same in different directories.